#include <alloc.h>
#include <string.h>
#include <stdlib.h>
#include "define.h"
#include "commands.h"
#include "cset.h"
#include "buffers.h"
#include "node.h"
#include "message.h"
#include "tools.h"
#include "hops.h"
#include "users.h"
#include "set.h"
#include "protocol.h"
#include "language.h"
#include "motd.h"
#include "usercmd.h"
#include "switch.h"		/*Pour le CSET_port de la version LINUX*/
#include "symbol.h"
#include "spy.h"

/*-------------------------------------------------------------------------
  ------ Rediriger les commandes SET ------------------------------------
  ------------------------------------------------------------------------
  La fonction return TRUE si la commande a ete executee                   */
#pragma argsused
int CSET_execute(int StreamNum, char * pCmd_p, int nParams, char **pArg, char **pStrArg)
{
  int Length;			/*Longueur de la commande*/

  if( *pArg[0] == SNULL )
    return FALSE;

  /*Longueur de la commande*/
  Length = strlen (pArg[0]);

  if( COMMANDS_check(pArg[0], "beep", Length, 2) )
    return CSET_beep(StreamNum, nParams, pArg, pStrArg);

  if( COMMANDS_check(pArg[0], "blackcall", Length, 5) )
    return CSET_blackcall(StreamNum, nParams, pArg, pStrArg);

  if( COMMANDS_check(pArg[0], "call", Length, 2) )
    return CSET_call(StreamNum, nParams, pArg, pStrArg);

  if( COMMANDS_check(pArg[0], "cfilter", Length, 4) )
    return CSET_cfilter(StreamNum, nParams, pArg, pStrArg);

  if( COMMANDS_check(pArg[0], "diddle", Length, 3) )
    return CSET_diddle(StreamNum, nParams, pArg, pStrArg);

  if( COMMANDS_check(pArg[0], "dxssid", Length, 3) )
    return CSET_dxssid(StreamNum, nParams, pArg, pStrArg);

  if( COMMANDS_check(pArg[0], "here", Length, 2) )
    return CSET_here(StreamNum, nParams, pArg, pStrArg);

  if( COMMANDS_check(pArg[0], "home", Length, 2) )
    return CSET_home(StreamNum, nParams, pArg, pStrArg);

  if( COMMANDS_check(pArg[0], "language", Length, 3) )
    return CSET_language(StreamNum, nParams, pArg, pStrArg);

  if( COMMANDS_check(pArg[0], "ldefault", Length, 4) )
    return CSET_ldefault(StreamNum, nParams, pArg, pStrArg);

  if( COMMANDS_check(pArg[0], "locator", Length, 3) )
    return CSET_locator(StreamNum, nParams, pArg, pStrArg);

  if( COMMANDS_check(pArg[0], "login", Length, 4) )
    return CSET_login(StreamNum, nParams, pArg, pStrArg);

  if( COMMANDS_check(pArg[0], "logs", Length, 3) )
    return CSET_logs(StreamNum, nParams, pArg, pStrArg);

  if( COMMANDS_check(pArg[0], "motd", Length, 3) )
    return CSET_motd(StreamNum, nParams, pArg, pStrArg);

#ifdef DOS
  if( COMMANDS_check(pArg[0], "mycall", Length, 2) )
    return CSET_mycall(StreamNum, nParams, pArg, pStrArg);
#endif

  if( COMMANDS_check(pArg[0], "name", Length, 3) )
    return CSET_name(StreamNum, nParams, pArg, pStrArg);
	
  if( COMMANDS_check(pArg[0], "nobeep", Length, 3) )
    return CSET_nobeep(StreamNum, nParams, pArg, pStrArg);

  if( COMMANDS_check(pArg[0], "nologin", Length, 3) )
    return CSET_nologin(StreamNum, nParams, pArg, pStrArg);

  if( COMMANDS_check(pArg[0], "node", Length, 1) )
    return CSET_node(StreamNum, nParams, pArg, pStrArg);

  if( COMMANDS_check(pArg[0], "nohere", Length, 3) )
    return CSET_nohere(StreamNum, nParams, pArg, pStrArg);

  if( ! strcmp(pArg[0], "qth") )
    return CSET_qth(StreamNum, nParams, pArg, pStrArg);

  if( ! strcmp(pArg[0], "tz") )
    return CSET_tz(StreamNum, nParams, pArg, pStrArg);

#ifdef DOS
  if( ! strcmp(pArg[0], "spy") )
    return CSET_spy(StreamNum, nParams, pArg, pStrArg);
#endif

  if( ! strcmp(pArg[0], "ssid") )
    return CSET_ssid(StreamNum, nParams, pArg, pStrArg);

  if( COMMANDS_check(pArg[0], "sysop", Length, 3) )
    return CSET_sysop(StreamNum, nParams, pArg, pStrArg);

  if( COMMANDS_check(pArg[0], "usercmd", Length, 5) )
    return CSET_usercmd(StreamNum, nParams, pArg, pStrArg);

#ifdef LINUX
  if( ! strcmp(pArg[0], "port") )
    return CSET_port(StreamNum, nParams, pArg, pStrArg);
#endif

  return FALSE;		/*La commande n'a pas ete trouvee*/
}

/*------------------------------------------------------------------------
  ------ SET/BEEP --------------------------------------------------------
  ------------------------------------------------------------------------*/
#pragma argsused
int CSET_beep(int StreamNum, int nParams, char **pArg, char **pStrArg)
{
  unsigned int iFlags;
  char	       szBuffer[256];
  extern char *MSG_pParams[10];


  if( nParams != 1 )
  {
    MSG_send(StreamNum, MSG58);		/*Nbr d'arg incorrect*/
    Prompt;
    return TRUE;
  }

  /*Modifier le flag (NOBEEP a mettre a 0)*/
  iFlags  = USERS_getFlags (StreamNum);
  iFlags &= ~USERS_NOBEEP;
  USERS_setFlags(StreamNum, iFlags);

  /* Affichage de confirmation de la commande */
  BUFFERS_printBuff(StreamNum, OUT, "%c", BELL);
  MSG_get(StreamNum, MSG63, szBuffer); /* valide */
  if( szBuffer[0] ) /* Si buffer non vide */
	szBuffer[strlen(szBuffer) - 1] = SNULL;
  MSG_pParams[9] = szBuffer;
  MSG_send(StreamNum, MSG65);

  Prompt;

  return TRUE;
}

/*------------------------------------------------------------------------
  ------ SET/BLACKCALL ---------------------------------------------------
  ------------------------------------------------------------------------*/
#pragma argsused
int CSET_blackcall(int StreamNum, int nParams, char **pArg, char **pStrArg)
{
  extern char	STREAMS_level[MAX_STREAMS];
  extern char  *PARAMS_blackCalls;

  /*Niveau d'utilisateur*/
  if( ! (STREAMS_level[StreamNum] & LEVEL_sysopV) )
    return FALSE;

  if( nParams != 1 )	  /*Seulement si des arguments ont ete donnes*/
    SET_params(PARAMS_blackCalls, pStrArg[1]);

   BUFFERS_printBuff(StreamNum, OUT, "SET/BLACKCALLS :%s\n",
		     PARAMS_blackCalls);

   Prompt;
   return TRUE;
}

/*------------------------------------------------------------------------
  ------ SET/CALL --------------------------------------------------------
  ------------------------------------------------------------------------*/
#pragma argsused
int CSET_call(int StreamNum, int nParams, char **pArg, char **pStrArg)
{
  extern char	STREAMS_level[MAX_STREAMS];
  extern char	STREAMS_callsign[MAX_STREAMS][10];
  char	sNodeCall[16];

  /* Ne pas autoriser les remote commands */
  if( StreamNum >= RCMD_VIRTSTREAM )
	return FALSE;

  /*Niveau d'utilisateur*/
  if( ! (STREAMS_level[StreamNum] & LEVEL_sysopV) )
    return FALSE;

  /*Sans argument, affiche le call actuel*/
  if( nParams == 1 )
  {
    BUFFERS_printBuff(StreamNum, OUT, "SET/CALL : %s\n",
		      NODE_getNodeCall(0, 0, sNodeCall) );
    Prompt;
    return TRUE;
  }

  /*Nombre d'arguments incorrect*/
  if( nParams > 2 )
  {
    MSG_send(StreamNum, MSG58);
    Prompt;
    return TRUE;
  }

  /*Indicatif en majuscules*/
  strupr (pArg[1]);

  /*Verifier que l'indicatif est valide*/
  if( ! TOOLS_isCall (pArg[1]) )
  {
    MSG_send(StreamNum, MSG18);
    Prompt;
    return TRUE;
  }

  BUFFERS_printBuff(StreamNum, OUT, "SET/CALL : %s\n     was : %s\n",
		    pArg[1],
		    NODE_getNodeCall(0, 0, sNodeCall) );

  NODE_myNodeCall (pArg[1]);
  HOPS_readFile(0, pArg[1]);

  strcpy(STREAMS_callsign[0],  pArg[1]); 	/*Indicatif ecran 0*/
  strcpy(STREAMS_callsign[65], pArg[1]);	/*Indicatif ecran 1*/

  /*Charger la config*/
  USERS_openRecord(0,  pArg[1]);
  USERS_openRecord(65, pArg[1]);

  Prompt;
  return TRUE;
}

/*------------------------------------------------------------------------
  ------ SET/CFILTER -----------------------------------------------------
  ------------------------------------------------------------------------*/
#pragma argsused
int CSET_cfilter(int StreamNum, int nParams, char **pArg, char **pStrArg)
{
  extern char	STREAMS_level[MAX_STREAMS];
  extern int	PARAMS_nCFilter;

  char	*pszString[] = {"- off",
			"- password required - closed system)",
			"- password required - RX only",
			"- no password required - RX only"};

  /*Niveau d'utilisateur*/
  if( ! (STREAMS_level[StreamNum] & LEVEL_sysopV) )
    return FALSE;

  /*Test 'theoriquement' inutile*/
  if( PARAMS_nCFilter < 0 || PARAMS_nCFilter > 3 )
    PARAMS_nCFilter = 0;

  /*Sans argument, affiche le mode actuel*/
  if( nParams == 1 )
  {
    BUFFERS_printBuff(StreamNum, OUT, "SET/CFILTER : %d %s\n",
		      PARAMS_nCFilter, pszString[PARAMS_nCFilter]);

    Prompt;
    return TRUE;
  }

  /*Nombre d'arguments incorrect*/
  if( nParams > 2 )
  {
    MSG_send(StreamNum, MSG58);
    Prompt;
    return TRUE;
  }

  /*Parametre*/
  strlwr (pArg[1]);
  if( strcmp(pArg[1], "off") && strcmp(pArg[1], "0") &&
      strcmp(pArg[1], "1")   && strcmp(pArg[1], "2") &&
      strcmp(pArg[1], "3") )
  {
    MSG_send(StreamNum, MSG18);
    BUFFERS_addBuff(StreamNum, "SET/CFILTER <n>\n"
			       " n = 0 -> CFILTER off\n"
			       " n = 1 -> CFILTER on / password required - closed system\n"
			       " n = 2 -> CFILTER on / password required - RX only\n"
			       " n = 3 -> CFILTER on / no password required - RX only\n",
			       OUT);
    Prompt;
    return TRUE;
  }

  BUFFERS_printBuff(StreamNum, OUT, "SET/CFILTER : %s %s\n        was : %d %s\n",
		    pArg[1], pszString[atoi (pArg[1])],
		    PARAMS_nCFilter, pszString[PARAMS_nCFilter]);

  PARAMS_nCFilter = atoi (pArg[1]);

  Prompt;
  return TRUE;
}

/*------------------------------------------------------------------------
  ------ SET/DIDDLE ------------------------------------------------------
  ------------------------------------------------------------------------*/
#pragma argsused
int CSET_diddle(int StreamNum, int nParams, char **pArg, char **pStrArg)
{
  extern char	STREAMS_level[MAX_STREAMS];
  extern int	PARAMS_iDefaultDiddle;

  /*Niveau d'utilisateur*/
  if( ! (STREAMS_level[StreamNum] & LEVEL_sysopV) )
    return FALSE;

  if( nParams > 2 )
  {
    MSG_send(StreamNum, MSG58);		/*Nbr d'arg incorrect*/
    Prompt;
    return TRUE;
  }

  if( nParams == 2 ) 			/*une valeur ?*/
    PARAMS_iDefaultDiddle = atoi (pArg[1]);

  /*Si le sysop entre la valeur 0, desactiver la commande (-> mettre -1)*/
  if( PARAMS_iDefaultDiddle == 0 )
    PARAMS_iDefaultDiddle = -1;

  BUFFERS_addBuff(StreamNum, "SET/DIDDLE : ", OUT);
  if( PARAMS_iDefaultDiddle > 0 )
    BUFFERS_printBuff(StreamNum, OUT, "%d s\n", PARAMS_iDefaultDiddle);
  else
    BUFFERS_addBuff(StreamNum, "off\n", OUT);

  Prompt;
  return TRUE;
}

#ifdef DOS
/*------------------------------------------------------------------------
  ------ SET/SPY ---------------------------------------------------------
  ------------------------------------------------------------------------*/
#pragma argsused
int CSET_spy(int StreamNum, int nParams, char **pArg, char **pStrArg)
{
  extern char	STREAMS_level[MAX_STREAMS];
  int	nPort;
  int	nHops;

  /* Ne pas autoriser les remote commands */
  if( StreamNum >= RCMD_VIRTSTREAM )
	return FALSE;

  /*Niveau d'utilisateur*/
  if( ! (STREAMS_level[StreamNum] & LEVEL_sysopV) )
    return FALSE;

  if( nParams == 1 || nParams > 3 )
  {
SPY_ERR:
    BUFFERS_addBuff(StreamNum, "SET/SPY <port> <hops>\n"
			       "<port> : 0-15\n"
			       "<hops> : 0-99\n", OUT);
    Prompt;
    return TRUE;
  }

  strlwr (pArg[1]);
  if( ! strcmp (pArg[1], "off") )
    nPort = -1;
  else
    nPort = atoi (pArg[1]);

  if( nPort != -1 && nParams != 3 )
    goto SPY_ERR;

  nHops = atoi (pArg[2]);

  if( nPort < -1 || nPort > 15 || nHops < 0 || nHops > 99 )
  {
    BUFFERS_addBuff(StreamNum, "*** Error : out of range.\n", OUT);
    goto SPY_ERR;
  }

  SPY_set(nPort, nHops);

  if( nPort != -1 )
    BUFFERS_printBuff(StreamNum, OUT,
		      "SET/SPY activated on port %d. Hop count set to %d\n",
		      nPort, nHops);
  else
    BUFFERS_addBuff(StreamNum, "SET/SPY disabled.\n", OUT);

  Prompt;
  return TRUE;
}
#endif

/*------------------------------------------------------------------------
  ------ SET/DXSSID ------------------------------------------------------
  ------------------------------------------------------------------------*/
#pragma argsused
int CSET_dxssid(int StreamNum, int nParams, char **pArg, char **pStrArg)
{
  extern char	STREAMS_level[MAX_STREAMS];
  extern int	PARAMS_iSetDxSsid;
  int	iDxSsid;

  /*Niveau d'utilisateur*/
  if( ! (STREAMS_level[StreamNum] & LEVEL_sysopV) )
    return FALSE;

  if( nParams == 1 )
  {
    BUFFERS_printBuff(StreamNum, OUT, "SET/DXSSID : %s\n", (PARAMS_iSetDxSsid ? "ON" : "OFF"));
    Prompt;
    return TRUE;
  }

  strupr (pArg[1]);

  if( ! strcmp(pArg[1], "ON") )
    iDxSsid = TRUE;   			/*Sur ON*/
  else
  if( ! strcmp(pArg[1], "OFF") )
    iDxSsid = FALSE;                    /*Sur OFF*/
  else
  {
    MSG_send(StreamNum, MSG18);         /*Erreur*/
    BUFFERS_addBuff(StreamNum, "Example : SET/SSID ON  or  SET/SSID OFF\n", OUT);
    Prompt;
    return TRUE;
  }

  /*Afficher le resultat et memoriser*/
  BUFFERS_printBuff(StreamNum, OUT, "SET/DXSSID : %s\n       was : %s\n",
		    (iDxSsid ? "ON" : "OFF"),
		    (PARAMS_iSetDxSsid ? "ON" : "OFF"));
  PARAMS_iSetDxSsid = iDxSsid;

  Prompt;
  return TRUE;
}

/*------------------------------------------------------------------------
  ------ SET/HERE --------------------------------------------------------
  ------------------------------------------------------------------------*/
#pragma argsused
int CSET_here(int StreamNum, int nParams, char **pArg, char **pStrArg)
{
  extern char	STREAMS_callsign[MAX_STREAMS][10];
  unsigned char	cFlag;
  char		sNodeCall[16];
  char		sUserCall[16];

  /* Ne pas autoriser les remote commands */
  if( StreamNum >= RCMD_VIRTSTREAM )
	return FALSE;

  if( nParams != 1 )
  {
    MSG_send(StreamNum, MSG58);		/*Nbr d'arg incorrect*/
    Prompt;
    return TRUE;
  }

  /*Rcuprer en mmoire les indicatifs du serveur et de l'utilisateur*/
  NODE_getNodeCall(0, 0, sNodeCall);
  strcpy(sUserCall, STREAMS_callsign[StreamNum]);

  /*Modifier la config en mmoire*/
  cFlag  = NODE_getUserFlag(sNodeCall, sUserCall);
  cFlag |= PROTOCOL_USER_HERE;
  NODE_setUserFlag(sNodeCall, sUserCall, cFlag);

  /*Transmettre l'info aux adjacents*/
  PROTOCOL_sendUserFlag(0, sNodeCall, sUserCall, cFlag, PROTOCOL_USER_HERE, 100);

  /*Message  l'utilisateur*/
  MSG_send(StreamNum, MSG27);

  Prompt;
  return TRUE;
}

/*------------------------------------------------------------------------
  ------ SET/HOME --------------------------------------------------------
  ------------------------------------------------------------------------*/
#pragma argsused
int CSET_home(int StreamNum, int nParams, char **pArg, char **pStrArg)
{
  extern tUser   *pUser;
  char	sNodeCall[16];

  /* Ne pas autoriser les remote commands */
  if( StreamNum >= RCMD_VIRTSTREAM )
	return FALSE;

  if( nParams != 2 )
  {
    MSG_send(StreamNum, MSG17);
    Prompt;
    return TRUE;
  }

  /*Limiter la longueur de l'indicatif : 9 car*/
  TOOLS_maxLength(pArg[1], 9);
  strupr (pArg[1]);

  /*Acceder au bloc utilisateur, mettre a jour et updater*/
  USERS_getRecord (StreamNum);
  strcpy(pUser->sHomeNode, pArg[1]);
  USERS_updateRecord (StreamNum);

  /*Transmettre l'info sur le reseau cluster*/
  NODE_getNodeCall(0, 0, sNodeCall);
  PROTOCOL_sendUserConfig(0, sNodeCall, pUser->sCallSign, pArg[1],
			  USERS_HOME, 100);

  MSG_send(StreamNum, MSG16);
  Prompt;
  return TRUE;
}

/*------------------------------------------------------------------------
  ------ SET/LANGUAGE ----------------------------------------------------
  ------------------------------------------------------------------------*/
#pragma argsused
int CSET_language(int StreamNum, int nParams, char **pArg, char **pStrArg)
{
  extern char	STREAMS_lang[MAX_STREAMS];
  extern tUser *pUser;
  int	iLang;

  /*L'utilisateur  t-il indiqu un numro ?*/
  if( nParams == 2 )
    iLang = atoi (pArg[1]) - 1;	/*Oui : le lire*/
  else
    iLang = STREAMS_lang[StreamNum];	/*Non : prendre l'actuel*/

  if( LANG_isDefined (iLang) )
  {
    /*Ok*/
    STREAMS_lang[StreamNum] = iLang;
    MSG_send(StreamNum, MSG10);

    /*Accder  la config user, et updater*/
    USERS_getRecord(StreamNum);
    pUser->cLanguage = iLang;
    USERS_updateRecord(StreamNum);
  }
  else
  {
    /*Cette langue n'est pas definie*/
    MSG_send(StreamNum, MSG11);
  }/*End IF*/

  Prompt;
  return TRUE;
}

/*------------------------------------------------------------------------
  ------ SET/LDEFAULT ----------------------------------------------------
  ------------------------------------------------------------------------*/
#pragma argsused
int CSET_ldefault(int StreamNum, int nParams, char **pArg, char **pStrArg)
{
  extern char	STREAMS_level[MAX_STREAMS];
  extern char	USERS_defaultLanguage;
  int	iLang;

  /* Ne pas autoriser les remote commands */
  if( StreamNum >= RCMD_VIRTSTREAM )
	return FALSE;

  /*Niveau d'utilisateur*/
  if( ! (STREAMS_level[StreamNum] & LEVEL_sysopV) )
    return FALSE;

  /*Le sysop a t-il indiqu un numro ?*/
  if( nParams == 2 )
    iLang = atoi (pArg[1]) - 1;				/*Oui : le lire*/
  else
    iLang = (unsigned int) USERS_defaultLanguage;       /*Non : prendre l'actuel*/

  if( LANG_isDefined (iLang) )
  {
    /*Ok*/
    USERS_defaultLanguage = (unsigned char) iLang;
    BUFFERS_printBuff(StreamNum, OUT, "Default language : %d.\n", iLang + 1);
  }
  else
  {
    /*Cette langue n'est pas definie*/
    MSG_send(StreamNum, MSG11);
  }/*End IF*/

   Prompt;
   return TRUE;
}

/*------------------------------------------------------------------------
  ------ SET/LOCATOR -----------------------------------------------------
  ------------------------------------------------------------------------*/
#pragma argsused
int CSET_locator(int StreamNum, int nParams, char **pArg, char **pStrArg)
{
  extern tUser   *pUser;
  char sNodeCall[16];

  /* Ne pas autoriser les remote commands */
  if( StreamNum >= RCMD_VIRTSTREAM )
	return FALSE;

  /*L'utilisateur  t-il indiqu le locator ?*/
  if( nParams != 2 )
  {
    /*Message d'erreur*/
    MSG_send(StreamNum, MSG58);

    Prompt;
    return TRUE;
  }

  /*Longueur dy locator*/
  if( strlen (pArg[1]) != 6 )
  {
    MSG_send(StreamNum, MSG18);

    Prompt;
    return TRUE;
  }

  strupr (pArg[1]);

  /*Accder au bloc user et updater*/
  USERS_getRecord(StreamNum);
  strcpy(pUser->sLocator, pArg[1]);
  USERS_updateRecord(StreamNum);

  /*Transmettre l'info sur le reseau cluster*/
  NODE_getNodeCall(0, 0, sNodeCall);
  PROTOCOL_sendUserConfig(0, sNodeCall, pUser->sCallSign,
			  pArg[1], USERS_LOCATOR, 100);

  /*Afficher le message*/
  MSG_send(StreamNum, MSG15);

  Prompt;
  return TRUE;
}

/*------------------------------------------------------------------------
  ------ SET/LOGIN -------------------------------------------------------
  ------------------------------------------------------------------------*/
#pragma argsused
int CSET_login(int StreamNum, int nParams, char **pArg, char **pStrArg)
{
  unsigned int iFlags;
  char	       szBuffer[256];
  extern char *MSG_pParams[10];

  /* Ne pas autoriser les remote commands */
  if( StreamNum >= RCMD_VIRTSTREAM )
	return FALSE;

  if( nParams != 1 )
  {
    MSG_send(StreamNum, MSG58);		/*Nbr d'arg incorrect*/
    Prompt;
    return TRUE;
  }

  /*Modifier le flag (NOLOGIN a mettre a 0)*/
  iFlags  = USERS_getFlags (StreamNum);
  iFlags &= ~USERS_NOLOGIN;
  USERS_setFlags(StreamNum, iFlags);

  /* Affichage de confirmation de la commande */
  MSG_get(StreamNum, MSG63, szBuffer); /* valide */
  if( szBuffer[0] ) /* Si buffer non vide */
	szBuffer[strlen(szBuffer) - 1] = SNULL;
  MSG_pParams[9] = szBuffer;
  MSG_send(StreamNum, MSG66);

  Prompt;

  return TRUE;
}

/*------------------------------------------------------------------------
  ------ SET/LOGS --------------------------------------------------------
  ------------------------------------------------------------------------*/
#pragma argsused
int CSET_logs(int StreamNum, int nParams, char **pArg, char **pStrArg)
{
  extern char	STREAMS_level[MAX_STREAMS];
  extern char  *PARAMS_logs;

  /* Ne pas autoriser les remote commands */
  if( StreamNum >= RCMD_VIRTSTREAM )
	return FALSE;

  /*Niveau d'utilisateur*/
  if( ! (STREAMS_level[StreamNum] & LEVEL_sysopV) )
    return FALSE;

  if( nParams != 1 )	  /*Seulement si des arguments ont ete donnes*/
    SET_params(PARAMS_logs, pStrArg[1]);

  BUFFERS_printBuff(StreamNum, OUT, "SET/LOGS :%s\n", PARAMS_logs);

  Prompt;
  return TRUE;
}

/*------------------------------------------------------------------------
  ------ SET/MOTD --------------------------------------------------------
  ------------------------------------------------------------------------*/
#pragma argsused
int CSET_motd(int StreamNum, int nParams, char **pArg, char **pStrArg)
{
  extern char	STREAMS_level[MAX_STREAMS];
  extern char	STREAMS_lang[MAX_STREAMS];

  /* Ne pas autoriser les remote commands */
  if( StreamNum >= RCMD_VIRTSTREAM )
	return FALSE;

  /*Niveau d'utilisateur*/
  if( ! (STREAMS_level[StreamNum] & LEVEL_sysopV) )
    return FALSE;

  if( nParams == 1 )
    MOTD_change(StreamNum, STREAMS_lang[StreamNum] + 1);
  else
    MOTD_change(StreamNum, atoi (pArg[1]));

  return TRUE;
}

#ifdef DOS
/*------------------------------------------------------------------------
  ------ SET/MYCALL ------------------------------------------------------
  ------------------------------------------------------------------------*/
#pragma argsused
int CSET_mycall(int StreamNum, int nParams, char **pArg, char **pStrArg)
{
  extern char	TERM_myCall[11];  /*L'indicatif du terminal*/
  extern char	STREAMS_level[MAX_STREAMS];

  /* Ne pas autoriser les remote commands */
  if( StreamNum >= RCMD_VIRTSTREAM )
	return FALSE;

  /*Niveau d'utilisateur*/
  if( ! (STREAMS_level[StreamNum] & LEVEL_sysopV) )
    return FALSE;

  if( nParams == 1 )
  {
    /*Si aucun parametre de precise, se contenter d'afficher le call*/
    BUFFERS_printBuff(StreamNum, OUT, "MyCall : %s\n", TERM_myCall);
    Prompt;
    return TRUE;
  }

  if( nParams > 2 )
  {
    /*Nombre d'arguments incorrect*/
    MSG_send(StreamNum, MSG58);
    Prompt;
    return TRUE;
  }

  TOOLS_maxLength(pArg[1], 9);
  strupr (pArg[1]);

  if( ! TOOLS_isCall(pArg[1]) )
  {
    /*Argument incorrect*/
    MSG_send(StreamNum, MSG18);
    Prompt;
    return TRUE;
  }

  /*Afficher et memoriser le nouveau call*/
  BUFFERS_printBuff(StreamNum, OUT, "MyCall : %s\n   Was : %s\n", pArg[1], TERM_myCall);
  strcpy(TERM_myCall, pArg[1]);

  Prompt;
  return TRUE;
}
#endif

/*------------------------------------------------------------------------
  ------ SET/NAME --------------------------------------------------------
  ------------------------------------------------------------------------*/
#pragma argsused
int CSET_name(int StreamNum, int nParams, char **pArg, char **pStrArg)
{
  extern tUser   *pUser;
  char sNodeCall[16];

  /* Ne pas autoriser les remote commands */
  if( StreamNum >= RCMD_VIRTSTREAM )
	return FALSE;

  /*L'utilisateur  t-il indiqu le prenom ?*/
  if( nParams == 1 )
  {
    MSG_send(StreamNum, MSG58);
    Prompt;
    return TRUE;
  }

  /*Longueur limitee a 22*/
  TOOLS_maxLength(pStrArg[1], 22);

  /*Accder au bloc user et updater*/
  USERS_getRecord(StreamNum);
  strcpy(pUser->sName, pStrArg[1]);
  USERS_updateRecord(StreamNum);

  /*Transmettre l'info sur le reseau cluster*/
  NODE_getNodeCall(0, 0, sNodeCall);
  PROTOCOL_sendUserConfig(0, sNodeCall, pUser->sCallSign,
			  pStrArg[1], USERS_NAME, 100);

  /*Afficher le message*/
  MSG_send(StreamNum, MSG13);

  Prompt;
  return TRUE;
}

/*------------------------------------------------------------------------
  ------ SET/NODE --------------------------------------------------------
  ------------------------------------------------------------------------*/
#pragma argsused
int CSET_node(int StreamNum, int nParams, char **pArg, char **pStrArg)
{
  extern char  *PARAMS_adjacentNodes;
  extern char	STREAMS_level[MAX_STREAMS];

  /*Niveau d'utilisateur*/
  if( ! (STREAMS_level[StreamNum] & LEVEL_sysopV) )
    return FALSE;

  if( nParams != 1 )	  /*Seulement si des arguments ont ete donnes*/
    SET_params(PARAMS_adjacentNodes, pStrArg[1]);

  BUFFERS_printBuff(StreamNum, OUT, "SET/NODE :%s\n", PARAMS_adjacentNodes);

  Prompt;
  return TRUE;
}

/*------------------------------------------------------------------------
  ------ SET/NOBEEP ------------------------------------------------------
  ------------------------------------------------------------------------*/
#pragma argsused
int CSET_nobeep(int StreamNum, int nParams, char **pArg, char **pStrArg)
{
  unsigned int iFlags;
  char         szBuffer[256];
  extern char *MSG_pParams[10];

  /* Ne pas autoriser les remote commands */
  if( StreamNum >= RCMD_VIRTSTREAM )
	return FALSE;

  if( nParams != 1 )
  {
    MSG_send(StreamNum, MSG58);		/*Nbr d'arg incorrect*/
    Prompt;
    return TRUE;
  }

  /*Modifier le flag (NOBEEP a mettre a 1)*/
  iFlags  = USERS_getFlags (StreamNum);
  iFlags |= USERS_NOBEEP;
  USERS_setFlags(StreamNum, iFlags);

  /* Affichage de confirmation de la commande */
  MSG_get(StreamNum, MSG64, szBuffer); /* valide */
  if( szBuffer[0] ) /* Si buffer non vide : enlever CR */
	szBuffer[strlen(szBuffer) - 1] = SNULL;
  MSG_pParams[9] = szBuffer;
  MSG_send(StreamNum, MSG65);

  Prompt;

  return TRUE;
}


/*------------------------------------------------------------------------
  ------ SET/NOHERE ------------------------------------------------------
  ------------------------------------------------------------------------*/
#pragma argsused
int CSET_nohere(int StreamNum, int nParams, char **pArg, char **pStrArg)
{
  extern char	STREAMS_callsign[MAX_STREAMS][10];
  unsigned char	cFlag;
  char		sNodeCall[16];
  char		sUserCall[16];

  /* Ne pas autoriser les remote commands */
  if( StreamNum >= RCMD_VIRTSTREAM )
	return FALSE;

  if( nParams != 1 )
  {
    MSG_send(StreamNum, MSG58);		/*Nbr d'arg incorrect*/
    Prompt;
    return TRUE;
  }

  /*Rcuprer en mmoire les indicatifs du serveur et de l'utilisateur*/
  NODE_getNodeCall(0, 0, sNodeCall);
  strcpy(sUserCall, STREAMS_callsign[StreamNum]);

  /*Modifier la config en mmoire*/
  cFlag  = NODE_getUserFlag(sNodeCall, sUserCall);
  cFlag &= ~PROTOCOL_USER_HERE;
  NODE_setUserFlag(sNodeCall, sUserCall, cFlag);

  /*Transmettre l'info aux adjacents*/
  PROTOCOL_sendUserFlag(0, sNodeCall, sUserCall, cFlag, PROTOCOL_USER_HERE, 100);

  /*Message  l'utilisateur*/
  MSG_send(StreamNum, MSG28);

  Prompt;
  return TRUE;
}

/*------------------------------------------------------------------------
  ------ SET/NOLOGIN -----------------------------------------------------
  ------------------------------------------------------------------------*/
#pragma argsused
int CSET_nologin(int StreamNum, int nParams, char **pArg, char **pStrArg)
{
  unsigned int iFlags;
  char         szBuffer[256];
  extern char *MSG_pParams[10];

  /* Ne pas autoriser les remote commands */
  if( StreamNum >= RCMD_VIRTSTREAM )
	return FALSE;

  if( nParams != 1 )
  {
    MSG_send(StreamNum, MSG58);		/*Nbr d'arg incorrect*/
    Prompt;
    return TRUE;
  }

  /*Modifier le flag (NOLOGIN a mettre a 1)*/
  iFlags  = USERS_getFlags (StreamNum);
  iFlags |= USERS_NOLOGIN;
  USERS_setFlags(StreamNum, iFlags);

  /* Affichage de confirmation de la commande */
  MSG_get(StreamNum, MSG64, szBuffer); /* valide */
  if( szBuffer[0] ) /* Si buffer non vide : enlever CR */
	szBuffer[strlen(szBuffer) - 1] = SNULL;
  MSG_pParams[9] = szBuffer;
  MSG_send(StreamNum, MSG66);

  Prompt;

  return TRUE;
}


/*------------------------------------------------------------------------
  ------ SET/QTH ---------------------------------------------------------
  ------------------------------------------------------------------------*/
#pragma argsused
int CSET_qth(int StreamNum, int nParams, char **pArg, char **pStrArg)
{
  extern tUser   *pUser;
  char sNodeCall[16];

  /* Ne pas autoriser les remote commands */
  if( StreamNum >= RCMD_VIRTSTREAM )
	return FALSE;

  /*L'utilisateur  t-il indiqu le qth ?*/
  if( nParams == 1 )
  {
    MSG_send(StreamNum, MSG58);
    Prompt;
    return TRUE;
  }

  /*Longueur limitee a 22*/
  TOOLS_maxLength(pStrArg[1], 80);

  /*Accder au bloc user et updater*/
  USERS_getRecord(StreamNum);
  strcpy(pUser->sQth, pStrArg[1]);
  USERS_updateRecord(StreamNum);

  /*Transmettre l'info sur le reseau cluster*/
  NODE_getNodeCall(0, 0, sNodeCall);
  PROTOCOL_sendUserConfig(0, sNodeCall, pUser->sCallSign,
			  pStrArg[1], USERS_QTH, 100);

  /*Afficher le message*/
  MSG_send(StreamNum, MSG14);

  Prompt;
  return TRUE;
}


/*------------------------------------------------------------------------
  ------ SET/TZ ----------------------------------------------------------
  ------------------------------------------------------------------------*/
#pragma argsused
int CSET_tz(int StreamNum, int nParams, char **pArg, char **pStrArg)
{
  extern char	STREAMS_level[MAX_STREAMS];
  extern long 	PARAMS_lTz;

  /*Niveau d'utilisateur*/
  if( ! (STREAMS_level[StreamNum] & LEVEL_sysopV) )
    return FALSE;

  if( nParams > 2 ) 	/*Pas plus d'1 arg*/
  {
    MSG_send(StreamNum, MSG58);
    Prompt;
    return TRUE;
  }

  if( nParams == 2 )	/*Si un arg a ete precise*/
    PARAMS_lTz = atol (pArg[1]) * 3600L;

  BUFFERS_printBuff(StreamNum, OUT, "SET/TZ : %ld\n", PARAMS_lTz / 3600L);

  Prompt;
  return TRUE;
}

/*------------------------------------------------------------------------
  ------ SET/SSID --------------------------------------------------------
  ------------------------------------------------------------------------*/
#pragma argsused
int CSET_ssid(int StreamNum, int nParams, char **pArg, char **pStrArg)
{
  extern char	STREAMS_level[MAX_STREAMS];
  extern char  *PARAMS_ssid;

  /*Niveau d'utilisateur*/
  if( ! (STREAMS_level[StreamNum] & LEVEL_sysopV) )
    return FALSE;

  if( nParams != 1 )		/*Seulement si des arguments ont ete donnes*/
    SET_params(PARAMS_ssid, pStrArg[1]);

  BUFFERS_printBuff(StreamNum, OUT, "SET/SSID :%s\n", PARAMS_ssid);

  Prompt;
  return TRUE;
}

/*------------------------------------------------------------------------
  ------ SET/SYSOP -------------------------------------------------------
  ------------------------------------------------------------------------*/
#pragma argsused
int CSET_sysop(int StreamNum, int nParams, char **pArg, char **pStrArg)
{
  extern char	STREAMS_level[MAX_STREAMS];
  extern char    *PARAMS_sysop;

  /* Ne pas autoriser les remote commands */
  if( StreamNum >= RCMD_VIRTSTREAM )
	return FALSE;

  /*Niveau d'utilisateur*/
  if( ! (STREAMS_level[StreamNum] & LEVEL_sysopV) )
    return FALSE;

  if( nParams != 1 )		/*Seulement si des arguments ont ete donnes*/
    SET_params(PARAMS_sysop, pStrArg[1]);

  BUFFERS_printBuff(StreamNum, OUT, "SET/SYSOP :%s\n", PARAMS_sysop);

  Prompt;
  return TRUE;
}

/*------------------------------------------------------------------------
  ------ SET/USERCMD -----------------------------------------------------
  ------------------------------------------------------------------------*/
#pragma argsused
int CSET_usercmd(int StreamNum, int nParams, char **pArg, char **pStrArg)
{
  extern char	STREAMS_level[MAX_STREAMS];

  /* Ne pas autoriser les remote commands */
  if( StreamNum >= RCMD_VIRTSTREAM )
	return FALSE;

  /*Rx only ?*/
  if( STREAMS_level[StreamNum] & LEVEL_user_RXonly )
    return FALSE;

  USERCMD_upload(StreamNum);
  return TRUE;
}


#ifdef LINUX
/*------------------------------------------------------------------------
  ------ SET/PORT (commande linux) ---------------------------------------
  ------------------------------------------------------------------------*/
#pragma argsused
int CSET_port(int StreamNum, int nParams, char **pArg, char **pStrArg)
{
  extern char	STREAMS_level[MAX_STREAMS];
  int	        index;

  /* Ne pas autoriser les remote commands */
  if( StreamNum >= RCMD_VIRTSTREAM )
	return FALSE;

  /*Niveau d'utilisateur*/
  if( ! (STREAMS_level[StreamNum] & LEVEL_sysopV) )
    return FALSE;

  BUFFERS_addBuff(StreamNum, "SET/PORT :", OUT);

  for(index = 1; index < MAX_ARG; index++)
    if (pArg[index][0])
    {
      BUFFERS_printBuff(StreamNum, OUT, " %s", pArg[index]);
      SWITCH_addPort (pArg[index]);
    }/*End IF*/

  BUFFERS_addBuff(StreamNum, "\n", OUT);
  Prompt;
  return TRUE;
}
#endif
